/**
 *                      ==================
 *                      IITK OSD Simulator
 *                      ==================
 *   An Implementation of Simulator for Object based storage device(OSD)
 *
 *   Copyright (C) 2007-2008 CSE IIT KANPUR
 *
 *   Contact: Department of Computer Science and Engineering
 *            Indian Institute of Technology,Kanpur(IIT Kanpur)
 *            {moona,riyaz}@cse.iitk.ac.in
 *
 *   This file is part of IITK OSD Simulator Project.
 *
 *   IITK OSD Simulator Project is free software; you can redistribute it
 *   and/or modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   IITK OSD Simulator Project is distributed in the hope that it will be
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General
 *   Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/*************************************************************
** Copyright 2004, 2005. IBM Corp.** All Rights Reserved.***
**************************************************************
** Redistribution and use in source and binary forms, with or without
** modifications, are permitted provided that the following conditions 
** are met:
** 
** i.  Redistribution of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**
** ii. Redistribution in binary form must reproduce the above copyright 
**     notice, this list of conditions and the following disclaimer in the 
**     documentation and/or other materials provided with the distribution.
**
** iii.Neither the name(s) of IBM Corp.** nor the names of its/their
**     contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
*******************************************************************
** THIS SOFTWARE IS PROVIDED BY IBM CORP. AND CONTRIBUTORS "AS IS" 
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING , BUT NOT LIMITED
** TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
** PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE IBM
** CORP. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
** INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
** (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
** OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
** HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
** STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
** OF THE POSSIBILITY OF SUCH DAMAGE.
** 
*****************************************************************************
*****************************************************************************/
/**
 *  Parts Copyright (C) 2007-2008 CSE IIT KANPUR
 **/

#ifndef OSD_ATTR_NUMBERS_H
#define OSD_ATTR_NUMBERS_H

#define OSD_MAX_ATTR_SIZE 65 
# define PAGE_ID_ATTR_SIZE 40
# define VENDOR_ID_SIZE 8
# define ATTR_PAGE_ID_SIZE 32 
# define PAGE_ID_ATTR_OFFSET 8
//////////////////////////////////////////////

// 4 bytes for page no + 4 bytes for page length
// we r not including attr 0 in page
# define PAGE_ATTR0_SIZE 8
# define OSD_ATTR_WRONG_OFFSET 1
# define PAGE_NO_SIZE 4
# define PAGE_LENGTH_SIZE 4
///////////////////////////////////////////////



#define PAGE_P ((uint32_t)0x30000000)
#define PAGE_C ((uint32_t)0x60000000)
#define PAGE_R ((uint32_t)0x90000000)
#define PAGE_U ((uint32_t)0)

# define PAGE_A 0

//-------------------------------------------------------------------


//OSD ROOT DIRECTORY PAGE
#define OSD_PAGE_NUM_ROOT_DIRECTORY PAGE_R+0     

#define OSD_ATTR_NUM_ROOT_DIRECTORY_page_id PAGE_R+0     
#define OSD_ATTR_NUM_ROOT_DIRECTORY_page_id_size 40
#define OSD_ATTR_NUM_ROOT_DIRECTORY_offset 0
#define OSD_ATTR_NUM_ROOT_DIRECTORY_set 0 

#define OSD_ATTR_NUM_ROOT_DIRECTORY_A1 PAGE_R+1     
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A1_size  40
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A1_offset 40
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A1_set 0

#define OSD_ATTR_NUM_ROOT_DIRECTORY_A2 PAGE_R+2
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A2_size 40
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A2_offset 80     
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A2_set 0     

#define OSD_ATTR_NUM_ROOT_DIRECTORY_A3 PAGE_R+3     
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A3_size 40
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A3_offset 120
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A3_set 0

#define OSD_ATTR_NUM_ROOT_DIRECTORY_A5 PAGE_R+5     
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A5_size 40
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A5_offset 160
#define OSD_ATTR_NUM_ROOT_DIRECTORY_A5_set 0

//-------------------------------------------------------------------

//OSD PARTITION DIRECTORY PAGE
#define OSD_PAGE_NUM_PART_DIRECTORY PAGE_P+0     
#define OSD_ATTR_NUM_PART_DIRECTORY_page_id PAGE_P+0
#define OSD_ATTR_NUM_PART_DIRECTORY_page_id_size 40
#define OSD_ATTR_NUM_PART_DIRECTORY_page_id_offset 0     
#define OSD_ATTR_NUM_PART_DIRECTORY_page_id_set 0     


#define OSD_ATTR_NUM_PART_DIRECTORY_A1 PAGE_P+1    
#define OSD_ATTR_NUM_PART_DIRECTORY_A1_size 40
#define OSD_ATTR_NUM_PART_DIRECTORY_A1_offset 40
 #define OSD_ATTR_NUM_PART_DIRECTORY_A1_set 0

#define OSD_ATTR_NUM_PART_DIRECTORY_A2 PAGE_P+2 
#define OSD_ATTR_NUM_PART_DIRECTORY_A2_size 40
#define OSD_ATTR_NUM_PART_DIRECTORY_A2_offset 80
#define OSD_ATTR_NUM_PART_DIRECTORY_A2_set 0


#define OSD_ATTR_NUM_PART_DIRECTORY_A3 PAGE_P+3     
#define OSD_ATTR_NUM_PART_DIRECTORY_A3_size 40
#define OSD_ATTR_NUM_PART_DIRECTORY_A3_offset 120
#define OSD_ATTR_NUM_PART_DIRECTORY_A3_set 0


#define OSD_ATTR_NUM_PART_DIRECTORY_A5 PAGE_P+5
#define OSD_ATTR_NUM_PART_DIRECTORY_A5_size 40
#define OSD_ATTR_NUM_PART_DIRECTORY_A5_offset 160     
#define OSD_ATTR_NUM_PART_DIRECTORY_A5_set 0     

//-------------------------------------------------------------------
#define OSD_PAGE_NUM_UOBJ_DIRECTORY PAGE_U+0     
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_page_id 0
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_page_id_size 40
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_page_id_offset  0
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_page_id_set  0

#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A1 PAGE_U+1    
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A1_size 40
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A1_offset 40
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A1_set 0

#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A2 PAGE_U+2 
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A2_size 40
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A2_offset 80

# define OSD_ATTR_NUM_UOBJ_DIRECTORY_A2_set 0

#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A3 PAGE_U+3 
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A3_size 40
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A3_offset 120
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A3_set 0

#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A4 PAGE_U+4
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A4_size  40  
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A4_offset 160
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A4_set 0   

#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A5 PAGE_U+5 
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A5_size 40
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A5_offset 200
#define OSD_ATTR_NUM_UOBJ_DIRECTORY_A5_set 0
//-------------------------------------------------------------------
//OSD ROOT INFO PAGE
#define OSD_PAGE_NUM_ROOT_INFO PAGE_R+1     
#define OSD_ATTR_NUM_ROOT_INFO_page_id 0

#define OSD_ATTR_NUM_ROOT_INFO_OSD_SYSTEM_ID 0x3     
#define OSD_ATTR_NUM_ROOT_INFO_OSD_SYSTEM_ID_size 20
#define OSD_ATTR_NUM_ROOT_INFO_OSD_SYSTEM_ID_offset PAGE_ATTR0_SIZE+0 
#define OSD_ATTR_NUM_ROOT_INFO_OSD_SYSTEM_ID_set 0 

#define OSD_ATTR_NUM_ROOT_INFO_VENDOR_ID 0x4     
#define OSD_ATTR_NUM_ROOT_INFO_VENDOR_ID_size 8
#define OSD_ATTR_NUM_ROOT_INFO_VENDOR_ID_offset PAGE_ATTR0_SIZE+20
#define OSD_ATTR_NUM_ROOT_INFO_VENDOR_ID_set 0

#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_ID 0x5     
#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_ID_size 16
#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_ID_offset  PAGE_ATTR0_SIZE+28
#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_ID_set  0

#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_MODEL 0x6 
#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_MODEL_size 32
#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_MODEL_offset  PAGE_ATTR0_SIZE+44
#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_MODEL_set 0

#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_REVISION_LEVEL 0x7     
#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_REVISION_LEVEL_size 4
#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_REVISION_LEVEL_offset  PAGE_ATTR0_SIZE+76
#define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_REVISION_LEVEL_set 0

#define OSD_ATTR_NUM_ROOT_INFO_SERIAL_NUMBER 0x8     
#define OSD_ATTR_NUM_ROOT_INFO_SERIAL_NUMBER_size 100 
#define OSD_ATTR_NUM_ROOT_INFO_SERIAL_NUMBER_offset  PAGE_ATTR0_SIZE+80
#define OSD_ATTR_NUM_ROOT_INFO_SERIAL_NUMBER_set 0

#define OSD_ATTR_NUM_ROOT_INFO_OSD_NAME 0x9     
#define OSD_ATTR_NUM_ROOT_INFO_OSD_NAME_size 100
#define OSD_ATTR_NUM_ROOT_INFO_OSD_NAME_offset PAGE_ATTR0_SIZE+180
#define OSD_ATTR_NUM_ROOT_INFO_OSD_NAME_set 1

#define OSD_ATTR_NUM_ROOT_INFO_TOTAL_CAPACITY 0x80     
#define OSD_ATTR_NUM_ROOT_INFO_TOTAL_CAPACITY_size  8
#define OSD_ATTR_NUM_ROOT_INFO_TOTAL_CAPACITY_offset  PAGE_ATTR0_SIZE+280
#define OSD_ATTR_NUM_ROOT_INFO_TOTAL_CAPACITY_set 0

#define OSD_ATTR_NUM_ROOT_INFO_USED_CAPACITY 0x81     
#define OSD_ATTR_NUM_ROOT_INFO_USED_CAPACITY_size 8
#define OSD_ATTR_NUM_ROOT_INFO_USED_CAPACITY_offset  PAGE_ATTR0_SIZE+288
#define OSD_ATTR_NUM_ROOT_INFO_USED_CAPACITY_set 0

#define OSD_ATTR_NUM_ROOT_INFO_NUM_OF_PARTITIONS 0xc0     
#define OSD_ATTR_NUM_ROOT_INFO_NUM_OF_PARTITIONS_size  8
#define OSD_ATTR_NUM_ROOT_INFO_NUM_OF_PARTITIONS_offset PAGE_ATTR0_SIZE+296
#define OSD_ATTR_NUM_ROOT_INFO_NUM_OF_PARTITIONS_set 0

#define OSD_ATTR_NUM_ROOT_INFO_CLOCK 0x100     
#define OSD_ATTR_NUM_ROOT_INFO_CLOCK_size 6
#define OSD_ATTR_NUM_ROOT_INFO_CLOCK_offset  PAGE_ATTR0_SIZE+304
#define OSD_ATTR_NUM_ROOT_INFO_CLOCK_set  0

//-------------------------------------------------------------------
//PART INFO PAGE 

#define OSD_PAGE_NUM_PART_INFO PAGE_P+1     
#define OSD_ATTR_NUM_PART_INFO_page_id 0


#define OSD_ATTR_NUM_PART_INFO_PARTITION_ID 0x1     
#define OSD_ATTR_NUM_PART_INFO_PARTITION_ID_size  8
#define OSD_ATTR_NUM_PART_INFO_PARTITION_ID_offset  PAGE_ATTR0_SIZE+0
#define OSD_ATTR_NUM_PART_INFO_PARTITION_ID_set 0


#define OSD_ATTR_NUM_PART_INFO_USERNAME 0x9     
#define OSD_ATTR_NUM_PART_INFO_USERNAME_size 100
#define OSD_ATTR_NUM_PART_INFO_USERNAME_offset  PAGE_ATTR0_SIZE+8
#define OSD_ATTR_NUM_PART_INFO_USERNAME_set 1

#define OSD_ATTR_NUM_PART_INFO_USED_CAPACITY 0x81
#define OSD_ATTR_NUM_PART_INFO_USED_CAPACITY_size  8
#define OSD_ATTR_NUM_PART_INFO_USED_CAPACITY_offset  PAGE_ATTR0_SIZE+108
#define OSD_ATTR_NUM_PART_INFO_USED_CAPACITY_set  0

#define OSD_ATTR_NUM_PART_INFO_NUM_OF_OBJECTS 0xC1  
#define OSD_ATTR_NUM_PART_INFO_NUM_OF_OBJECTS_size 8
#define OSD_ATTR_NUM_PART_INFO_NUM_OF_OBJECTS_offset PAGE_ATTR0_SIZE+116
#define OSD_ATTR_NUM_PART_INFO_NUM_OF_OBJECTS_set 0


//-------------------------------------------------------------------
//UOBJECT INFO PAGE
#define OSD_PAGE_NUM_UOBJ_INFO PAGE_U+0x1     
#define OSD_ATTR_NUM_UOBJ_INFO_page_id 0

#define OSD_ATTR_NUM_UOBJ_INFO_PARTITION_ID 0x1     
#define OSD_ATTR_NUM_UOBJ_INFO_PARTITION_ID_size 8
#define OSD_ATTR_NUM_UOBJ_INFO_PARTITION_ID_offset PAGE_ATTR0_SIZE+0
#define OSD_ATTR_NUM_UOBJ_INFO_PARTITION_ID_set 0


#define OSD_ATTR_NUM_UOBJ_INFO_OBJECT_ID 0x2     
#define OSD_ATTR_NUM_UOBJ_INFO_OBJECT_ID_size 8
#define OSD_ATTR_NUM_UOBJ_INFO_OBJECT_ID_offset PAGE_ATTR0_SIZE+8
#define OSD_ATTR_NUM_UOBJ_INFO_OBJECT_ID_set 0

#define OSD_ATTR_NUM_UOBJ_INFO_USERNAME 0x9     
#define OSD_ATTR_NUM_UOBJ_INFO_USERNAME_size 100
#define OSD_ATTR_NUM_UOBJ_INFO_USERNAME_offset  PAGE_ATTR0_SIZE+16
#define OSD_ATTR_NUM_UOBJ_INFO_USERNAME_set  1

#define OSD_ATTR_NUM_UOBJ_INFO_USED_CAPACITY 0x81     
#define OSD_ATTR_NUM_UOBJ_INFO_USED_CAPACITY_size 8
#define OSD_ATTR_NUM_UOBJ_INFO_USED_CAPACITY_offset  PAGE_ATTR0_SIZE+116
#define OSD_ATTR_NUM_UOBJ_INFO_USED_CAPACITY_set  0


#define OSD_ATTR_NUM_UOBJ_INFO_OBJ_LENGTH 0x82     
#define OSD_ATTR_NUM_UOBJ_INFO_OBJ_LENGTH_size  8
#define OSD_ATTR_NUM_UOBJ_INFO_OBJ_LENGTH_offset  PAGE_ATTR0_SIZE+124
#define OSD_ATTR_NUM_UOBJ_INFO_OBJ_LENGTH_set  1

//-------------------------------------------------------------------
//-------------------------------------------------------------------
//DONT KNOW  abt UOBJECT PRIV_INFO
#define OSD_PAGE_NUM_T10_USER_OC_PRIV_INFO PAGE_U+0x10     
#define OSD_ATTR_NUM_T10_USER_OC_PRIV_INFO_page_id 0
#define OSD_ATTR_NUM_T10_USER_OC_PRIV_INFO_GENERAL0 0x1     
#define OSD_ATTR_NUM_T10_USER_OC_PRIV_INFO_GENERAL1 0x2     
#define OSD_ATTR_NUM_T10_USER_OC_PRIV_INFO_GENERAL2 0x3     
#define OSD_ATTR_NUM_T10_USER_OC_PRIV_INFO_GENERAL3 0x4     
#define OSD_ATTR_NUM_T10_USER_OC_PRIV_INFO_GENERAL4 0x5     
#define OSD_ATTR_NUM_T10_USER_OC_PRIV_INFO_DL_NEXT 0x6     
#define OSD_ATTR_NUM_T10_USER_OC_PRIV_INFO_DL_PREV 0x7     
#define OSD_ATTR_NUM_T10_USER_OC_PRIV_INFO_DEL_CURSOR 0x8     

//DONT KNOW abt PARTITION PRIV_INFO
#define OSD_PAGE_NUM_PART_OC_PRIV_INFO PAGE_P+0x10     
#define OSD_ATTR_NUM_PART_OC_PRIV_INFO_page_id 0
#define OSD_ATTR_NUM_PART_OC_PRIV_INFO_NUM_OBJECTS 0x2     

//DONT KNOW abt ROOT PRIV_INFO
#define OSD_PAGE_NUM_ROOT_OC_PRIV_INFO PAGE_R+0x10     
#define OSD_ATTR_NUM_ROOT_OC_PRIV_INFO_page_id 0
#define OSD_ATTR_NUM_ROOT_OC_PRIV_INFO_TDLIST_ROOT_LBA 0x1     
//-------------------------------------------------------------------
//-------------------------------------------------------------------
//ROOT QUOTA PAGE
#define OSD_PAGE_NUM_ROOT_QUOTAS PAGE_R+0x2     
#define OSD_ATTR_NUM_ROOT_QUOTAS_page_id 0

#define OSD_ATTR_NUM_ROOT_QUOTAS_DEFAULT_MAX_OBJ_LEN 0x1
#define OSD_ATTR_NUM_ROOT_QUOTAS_DEFAULT_MAX_OBJ_LEN_size 8
#define OSD_ATTR_NUM_ROOT_QUOTAS_DEFAULT_MAX_OBJ_LEN_offset  PAGE_ATTR0_SIZE+0

#define OSD_ATTR_NUM_ROOT_QUOTAS_DEFAULT_MAX_OBJ_LEN_set  1

#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_CAPACITY_QUOTA 0x10001     
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_CAPACITY_QUOTA_size 8
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_CAPACITY_QUOTA_offset PAGE_ATTR0_SIZE+8
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_CAPACITY_QUOTA_set 1


#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_OBJ_COUNT 0x10002    
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_OBJ_COUNT_size  8
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_OBJ_COUNT_offset PAGE_ATTR0_SIZE+16
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_OBJ_COUNT_set 1
 

#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COLLECTIONS_PER_OBJ 0x10081     
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COLLECTIONS_PER_OBJ_size 4
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COLLECTIONS_PER_OBJ_offset PAGE_ATTR0_SIZE+24
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COLLECTIONS_PER_OBJ_set 1


#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COUNT 0x20002     
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COUNT_size 8
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COUNT_offset  PAGE_ATTR0_SIZE+28
#define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COUNT_set  1

//-------------------------------------------------------------------
//PART QUOTA PAGE
#define OSD_PAGE_NUM_PART_QUOTAS PAGE_P+0x2     
#define OSD_ATTR_NUM_PART_QUOTAS_page_id 0

#define OSD_ATTR_NUM_PART_QUOTAS_DEFAULT_MAX_OBJ_LEN 0x1     
#define OSD_ATTR_NUM_PART_QUOTAS_DEFAULT_MAX_OBJ_LEN_size  8
#define OSD_ATTR_NUM_PART_QUOTAS_DEFAULT_MAX_OBJ_LEN_offset PAGE_ATTR0_SIZE+0 
#define OSD_ATTR_NUM_PART_QUOTAS_DEFAULT_MAX_OBJ_LEN_set 1

#define OSD_ATTR_NUM_PART_QUOTAS_CAPACITY_QUOTA 0x10001     
#define OSD_ATTR_NUM_PART_QUOTAS_CAPACITY_QUOTA_size 8
#define OSD_ATTR_NUM_PART_QUOTAS_CAPACITY_QUOTA_offset PAGE_ATTR0_SIZE+8
#define OSD_ATTR_NUM_PART_QUOTAS_CAPACITY_QUOTA_set 1

#define OSD_ATTR_NUM_PART_QUOTAS_OBJ_COUNT 0x10002     
#define OSD_ATTR_NUM_PART_QUOTAS_OBJ_COUNT_size 8
#define OSD_ATTR_NUM_PART_QUOTAS_OBJ_COUNT_offset  PAGE_ATTR0_SIZE+16
#define OSD_ATTR_NUM_PART_QUOTAS_OBJ_COUNT_set  1


#define OSD_ATTR_NUM_PART_QUOTAS_COLLECTIONS_PER_OBJ 0x10081     
#define OSD_ATTR_NUM_PART_QUOTAS_COLLECTIONS_PER_OBJ_size 4
#define OSD_ATTR_NUM_PART_QUOTAS_COLLECTIONS_PER_OBJ_offset PAGE_ATTR0_SIZE+24
#define OSD_ATTR_NUM_PART_QUOTAS_COLLECTIONS_PER_OBJ_set 1

//-------------------------------------------------------------------
//UOBJECT QUOTA
#define OSD_PAGE_NUM_UOBJ_QUOTAS PAGE_U+0x2     
#define OSD_ATTR_NUM_UOBJ_QUOTAS_page_id 0

#define OSD_ATTR_NUM_UOBJ_QUOTAS_MAX_OBJ_LEN 0x1     
#define OSD_ATTR_NUM_UOBJ_QUOTAS_MAX_OBJ_LEN_size 8
#define OSD_ATTR_NUM_UOBJ_QUOTAS_MAX_OBJ_LEN_offset  PAGE_ATTR0_SIZE+0
#define OSD_ATTR_NUM_UOBJ_QUOTAS_MAX_OBJ_LEN_set  1
//-------------------------------------------------------------------

//ROOT TIMESTAMP 
#define OSD_PAGE_NUM_ROOT_TIMESTAMPS PAGE_R+0x3     
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_page_id 0

#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_ATTR_ACCESSED_TIME 0x2
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_ATTR_ACCESSED_TIME_size 6
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_ATTR_ACCESSED_TIME_offset   PAGE_ATTR0_SIZE+0    
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_ATTR_ACCESSED_TIME_set   0


#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_ATTR_MODIFIED_TIME 0x3     
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_ATTR_MODIFIED_TIME_size 6
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_ATTR_MODIFIED_TIME_offset  PAGE_ATTR0_SIZE+6
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_ATTR_MODIFIED_TIME_set  0

#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_TIMESTAMP_BYPASS 0xfffffffe     
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_TIMESTAMP_BYPASS_size 1
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_TIMESTAMP_BYPASS_offset  PAGE_ATTR0_SIZE+12
#define OSD_ATTR_NUM_ROOT_TIMESTAMPS_TIMESTAMP_BYPASS_set  1

//-------------------------------------------------------------------
//PARTITION TIMESTAMP
#define OSD_PAGE_NUM_PART_TIMESTAMPS PAGE_P+0x3     
#define OSD_ATTR_NUM_PART_TIMESTAMPS_page_id 0

#define OSD_ATTR_NUM_PART_TIMESTAMPS_CREATED_TIME 0x1     
#define OSD_ATTR_NUM_PART_TIMESTAMPS_CREATED_TIME_size  6
#define OSD_ATTR_NUM_PART_TIMESTAMPS_CREATED_TIME_offset  PAGE_ATTR0_SIZE+0
#define OSD_ATTR_NUM_PART_TIMESTAMPS_CREATED_TIME_set  0

#define OSD_ATTR_NUM_PART_TIMESTAMPS_ATTR_ACCESSED_TIME 0x2     
#define OSD_ATTR_NUM_PART_TIMESTAMPS_ATTR_ACCESSED_TIME_size 6
#define OSD_ATTR_NUM_PART_TIMESTAMPS_ATTR_ACCESSED_TIME_offset  PAGE_ATTR0_SIZE+6 
#define OSD_ATTR_NUM_PART_TIMESTAMPS_ATTR_ACCESSED_TIME_set 0


#define OSD_ATTR_NUM_PART_TIMESTAMPS_ATTR_MODIFIED_TIME 0x3     
#define OSD_ATTR_NUM_PART_TIMESTAMPS_ATTR_MODIFIED_TIME_size 6
#define OSD_ATTR_NUM_PART_TIMESTAMPS_ATTR_MODIFIED_TIME_offset  PAGE_ATTR0_SIZE+12 
#define OSD_ATTR_NUM_PART_TIMESTAMPS_ATTR_MODIFIED_TIME_set 0


#define OSD_ATTR_NUM_PART_TIMESTAMPS_DATA_ACCESSED_TIME 0x4     
#define OSD_ATTR_NUM_PART_TIMESTAMPS_DATA_ACCESSED_TIME_size 6
#define OSD_ATTR_NUM_PART_TIMESTAMPS_DATA_ACCESSED_TIME_offset   PAGE_ATTR0_SIZE+18
#define OSD_ATTR_NUM_PART_TIMESTAMPS_DATA_ACCESSED_TIME_set  0

#define OSD_ATTR_NUM_PART_TIMESTAMPS_DATA_MODIFIED_TIME 0x5
#define OSD_ATTR_NUM_PART_TIMESTAMPS_DATA_MODIFIED_TIME_size 6
#define OSD_ATTR_NUM_PART_TIMESTAMPS_DATA_MODIFIED_TIME_offset     PAGE_ATTR0_SIZE+24 
#define OSD_ATTR_NUM_PART_TIMESTAMPS_DATA_MODIFIED_TIME_set    0

#define OSD_ATTR_NUM_PART_TIMESTAMPS_TIMESTAMP_BYPASS 0xfffffffe  
#define OSD_ATTR_NUM_PART_TIMESTAMPS_TIMESTAMP_BYPASS_size 1
#define OSD_ATTR_NUM_PART_TIMESTAMPS_TIMESTAMP_BYPASS_offset  PAGE_ATTR0_SIZE+30
#define OSD_ATTR_NUM_PART_TIMESTAMPS_TIMESTAMP_BYPASS_set 1
//-------------------------------------------------------------------
//UOBJECT TIMESTAMP
#define OSD_PAGE_NUM_UOBJ_TIMESTAMPS PAGE_U+0x3     
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_page_id 0

#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_CREATED_TIME 0x1
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_CREATED_TIME_size 6
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_CREATED_TIME_offset  PAGE_ATTR0_SIZE+0    
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_CREATED_TIME_set  0

#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_ATTR_ACCESSED_TIME 0x2     
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_ATTR_ACCESSED_TIME_size 6
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_ATTR_ACCESSED_TIME_offset PAGE_ATTR0_SIZE+6
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_ATTR_ACCESSED_TIME_set 0


#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_ATTR_MODIFIED_TIME 0x3   
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_ATTR_MODIFIED_TIME_size 6
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_ATTR_MODIFIED_TIME_offset PAGE_ATTR0_SIZE+12
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_ATTR_MODIFIED_TIME_set 0
  

#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_DATA_ACCESSED_TIME 0x4    
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_DATA_ACCESSED_TIME_size 6
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_DATA_ACCESSED_TIME_offset PAGE_ATTR0_SIZE+18
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_DATA_ACCESSED_TIME_set 0

#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_DATA_MODIFIED_TIME 0x5
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_DATA_MODIFIED_TIME_size 6
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_DATA_MODIFIED_TIME_offset PAGE_ATTR0_SIZE+24      
#define OSD_ATTR_NUM_UOBJ_TIMESTAMPS_DATA_MODIFIED_TIME_set 0
//-------------------------------------------------------------------
//UBOJECT COLLECTION
#define OSD_PAGE_NUM_T10_COLLECTIONS PAGE_U+0x4     
#define OSD_ATTR_NUM_T10_COLLECTIONS_page_id 0
//-------------------------------------------------------------------

//ROOT SECURITY
#define OSD_PAGE_NUM_ROOT_SECURITY PAGE_R+0x5     
#define OSD_ATTR_NUM_ROOT_SECURITY_page_id 0

#define OSD_ATTR_NUM_ROOT_SECURITY_DEFAULT_SEC_METHOD 0x1     
#define OSD_ATTR_NUM_ROOT_SECURITY_DEFAULT_SEC_METHOD_size 1     
#define OSD_ATTR_NUM_ROOT_SECURITY_DEFAULT_SEC_METHOD_offset PAGE_ATTR0_SIZE+0
#define OSD_ATTR_NUM_ROOT_SECURITY_DEFAULT_SEC_METHOD_set 1   



#define OSD_ATTR_NUM_ROOT_SECURITY_OLDEST_VALID_NONCE 0x2     
#define OSD_ATTR_NUM_ROOT_SECURITY_OLDEST_VALID_NONCE_size 6     
#define OSD_ATTR_NUM_ROOT_SECURITY_OLDEST_VALID_NONCE_offset  PAGE_ATTR0_SIZE+1    
#define OSD_ATTR_NUM_ROOT_SECURITY_OLDEST_VALID_NONCE_set 0


#define OSD_ATTR_NUM_ROOT_SECURITY_NEWEST_VALID_NONCE 0x3     
#define OSD_ATTR_NUM_ROOT_SECURITY_NEWEST_VALID_NONCE_size 6     
#define OSD_ATTR_NUM_ROOT_SECURITY_NEWEST_VALID_NONCE_offset PAGE_ATTR0_SIZE+7
#define OSD_ATTR_NUM_ROOT_SECURITY_NEWEST_VALID_NONCE_set 0    


#define OSD_ATTR_NUM_ROOT_SECURITY_PARTITION_DEFAULT_SEC_METHOD 0x6     
#define OSD_ATTR_NUM_ROOT_SECURITY_PARTITION_DEFAULT_SEC_METHOD_size  1   
#define OSD_ATTR_NUM_ROOT_SECURITY_PARTITION_DEFAULT_SEC_METHOD_offset PAGE_ATTR0_SIZE+13      
#define OSD_ATTR_NUM_ROOT_SECURITY_PARTITION_DEFAULT_SEC_METHOD_set 1


#define OSD_ATTR_NUM_ROOT_SECURITY_SUPPORTED_SEC_METHODS 0x7     
#define OSD_ATTR_NUM_ROOT_SECURITY_SUPPORTED_SEC_METHODS_size 2     
#define OSD_ATTR_NUM_ROOT_SECURITY_SUPPORTED_SEC_METHODS_offset PAGE_ATTR0_SIZE+14      
#define OSD_ATTR_NUM_ROOT_SECURITY_SUPPORTED_SEC_METHODS_set 0


#define OSD_ATTR_NUM_ROOT_SECURITY_ADJUSTABLE_CLOCK 0x9     
#define OSD_ATTR_NUM_ROOT_SECURITY_ADJUSTABLE_CLOCK_size   6   
#define OSD_ATTR_NUM_ROOT_SECURITY_ADJUSTABLE_CLOCK_offset PAGE_ATTR0_SIZE+16
#define OSD_ATTR_NUM_ROOT_SECURITY_ADJUSTABLE_CLOCK_set 1


#define OSD_ATTR_NUM_ROOT_SECURITY_MASTER_KEY_ID 0x7FFD     
#define OSD_ATTR_NUM_ROOT_SECURITY_MASTER_KEY_ID_size 7     
#define OSD_ATTR_NUM_ROOT_SECURITY_MASTER_KEY_ID_offset PAGE_ATTR0_SIZE+22     
#define OSD_ATTR_NUM_ROOT_SECURITY_MASTER_KEY_ID_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ROOT_KEY_ID 0x7FFE     
#define OSD_ATTR_NUM_ROOT_SECURITY_ROOT_KEY_ID_size 7
#define OSD_ATTR_NUM_ROOT_SECURITY_ROOT_KEY_ID_offset PAGE_ATTR0_SIZE+29
#define OSD_ATTR_NUM_ROOT_SECURITY_ROOT_KEY_ID_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_1 0x80000000+0     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_1_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_1_offset PAGE_ATTR0_SIZE+36
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_1_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_2 0x80000000+1     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_2_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_2_offset  PAGE_ATTR0_SIZE+37
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_2_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_3 0x80000000+2     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_3_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_3_offset PAGE_ATTR0_SIZE+38
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_3_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_4 0x80000000+3     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_4_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_4_offset PAGE_ATTR0_SIZE+39
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_4_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_5 0x80000000+4     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_5_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_5_offset PAGE_ATTR0_SIZE+40
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_5_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_6 0x80000000+5     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_6_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_6_offset PAGE_ATTR0_SIZE+41
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_6_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_7 0x80000000+6     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_7_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_7_offset PAGE_ATTR0_SIZE+42
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_7_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_8 0x80000000+7     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_8_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_8_offset PAGE_ATTR0_SIZE+43
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_8_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_9 0x80000000+8     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_9_size  1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_9_offset  PAGE_ATTR0_SIZE+44
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_9_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_10 0x80000000+9     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_10_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_10_offset PAGE_ATTR0_SIZE+45
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_10_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_11 0x80000000+10     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_11_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_11_offset PAGE_ATTR0_SIZE+46
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_11_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_12 0x80000000+11     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_12_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_12_offset PAGE_ATTR0_SIZE+47
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_12_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_13 0x80000000+12     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_13_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_13_offset PAGE_ATTR0_SIZE+48
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_13_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_14 0x80000000+13     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_14_size  1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_14_offset PAGE_ATTR0_SIZE+49
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_14_set 0


#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_15 0x80000000+14     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_15_size  1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_15_offset PAGE_ATTR0_SIZE+50
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_15_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_16 0x80000000+15     
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_16_size  1
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_16_offset PAGE_ATTR0_SIZE+51
#define OSD_ATTR_NUM_ROOT_SECURITY_ALG_16_set 0

#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_1 0x80000010+0     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_2 0x80000010+1     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_3 0x80000010+2     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_4 0x80000010+3     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_5 0x80000010+4     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_6 0x80000010+5     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_7 0x80000010+6     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_8 0x80000010+7     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_9 0x80000010+8     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_10 0x80000010+9     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_11 0x80000010+10     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_12 0x80000010+11     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_13 0x80000010+12     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_14 0x80000010+13     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_15 0x80000010+14     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_16 0x80000010+15     


#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_1_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_2_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_3_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_4_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_5_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_6_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_7_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_8_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_9_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_10_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_11_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_12_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_13_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_14_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_15_size 1
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_16_size 1

#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_1_offset PAGE_ATTR0_SIZE+52
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_2_offset PAGE_ATTR0_SIZE+53
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_3_offset PAGE_ATTR0_SIZE+54
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_4_offset PAGE_ATTR0_SIZE+55
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_5_offset PAGE_ATTR0_SIZE+56
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_6_offset PAGE_ATTR0_SIZE+57
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_7_offset PAGE_ATTR0_SIZE+58
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_8_offset PAGE_ATTR0_SIZE+59
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_9_offset PAGE_ATTR0_SIZE+60
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_10_offset PAGE_ATTR0_SIZE+61     
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_11_offset PAGE_ATTR0_SIZE+62 
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_12_offset PAGE_ATTR0_SIZE+63 
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_13_offset PAGE_ATTR0_SIZE+64
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_14_offset PAGE_ATTR0_SIZE+65
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_15_offset PAGE_ATTR0_SIZE+66 
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_16_offset PAGE_ATTR0_SIZE+67 


#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_1_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_2_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_3_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_4_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_5_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_6_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_7_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_8_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_9_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_10_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_11_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_12_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_13_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_14_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_15_set 0
#define OSD_ATTR_NUM_ROOT_SECURITY_DH_GROUP_16_set 0


//-------------------------------------------------------------------
//-------------------------------------------------------------------
//PART SECURITY
#define OSD_PAGE_NUM_PART_SECURITY PAGE_P+0x5     
#define OSD_ATTR_NUM_PART_SECURITY_page_id 0


#define OSD_ATTR_NUM_PART_SECURITY_DEFAULT_SEC_METHOD 0x1     
#define OSD_ATTR_NUM_PART_SECURITY_OLDEST_VALID_NONCE 0x2     
#define OSD_ATTR_NUM_PART_SECURITY_NEWEST_VALID_NONCE 0x3     
#define OSD_ATTR_NUM_PART_SECURITY_REQ_NONCE_LIST_DEPTH 0x4     
#define OSD_ATTR_NUM_PART_SECURITY_FROZEN_KEYS_MASK 0x5     
#define OSD_ATTR_NUM_PART_SECURITY_PARTITION_KEY_ID 0x7FFF     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_0 0x8000+0     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_1 0x8000+1     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_2 0x8000+2     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_3 0x8000+3     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_4 0x8000+4     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_5 0x8000+5     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_6 0x8000+6     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_7 0x8000+7     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_8 0x8000+8     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_9 0x8000+9     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_10 0x8000+10     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_11 0x8000+11     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_12 0x8000+12     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_13 0x8000+13     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_14 0x8000+14     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_15 0x8000+15     
#define OSD_ATTR_NUM_PART_SECURITY_POLICY_ACCESS_TAG 0x40000001     
#define OSD_ATTR_NUM_PART_SECURITY_USER_OBJ_POLICY_ACCESS_TAG 0x40000002     

#define OSD_ATTR_NUM_PART_SECURITY_DEFAULT_SEC_METHOD_size 1
#define OSD_ATTR_NUM_PART_SECURITY_OLDEST_VALID_NONCE_size 6    
#define OSD_ATTR_NUM_PART_SECURITY_NEWEST_VALID_NONCE_size 6
#define OSD_ATTR_NUM_PART_SECURITY_REQ_NONCE_LIST_DEPTH_size 2     
#define OSD_ATTR_NUM_PART_SECURITY_FROZEN_KEYS_MASK_size 2    
#define OSD_ATTR_NUM_PART_SECURITY_PARTITION_KEY_ID_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_0_size 7     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_1_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_2_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_3_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_4_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_5_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_6_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_7_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_8_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_9_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_10_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_11_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_12_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_13_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_14_size 7
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_15_size 7
#define OSD_ATTR_NUM_PART_SECURITY_POLICY_ACCESS_TAG_size 4
#define OSD_ATTR_NUM_PART_SECURITY_USER_OBJ_POLICY_ACCESS_TAG_size 4



#define OSD_ATTR_NUM_PART_SECURITY_DEFAULT_SEC_METHOD_offset  PAGE_ATTR0_SIZE+0    
#define OSD_ATTR_NUM_PART_SECURITY_OLDEST_VALID_NONCE_offset  PAGE_ATTR0_SIZE+1         
#define OSD_ATTR_NUM_PART_SECURITY_NEWEST_VALID_NONCE_offset  PAGE_ATTR0_SIZE+7    
#define OSD_ATTR_NUM_PART_SECURITY_REQ_NONCE_LIST_DEPTH_offset  PAGE_ATTR0_SIZE+13    
#define OSD_ATTR_NUM_PART_SECURITY_FROZEN_KEYS_MASK_offset  PAGE_ATTR0_SIZE+15    
#define OSD_ATTR_NUM_PART_SECURITY_PARTITION_KEY_ID_offset  PAGE_ATTR0_SIZE+17    

#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_0_offset  PAGE_ATTR0_SIZE+24    
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_1_offset  PAGE_ATTR0_SIZE+31       
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_2_offset  PAGE_ATTR0_SIZE+38     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_3_offset PAGE_ATTR0_SIZE+45     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_4_offset PAGE_ATTR0_SIZE+52     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_5_offset PAGE_ATTR0_SIZE+59     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_6_offset PAGE_ATTR0_SIZE+66     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_7_offset PAGE_ATTR0_SIZE+73     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_8_offset PAGE_ATTR0_SIZE+80     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_9_offset PAGE_ATTR0_SIZE+87     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_10_offset PAGE_ATTR0_SIZE+94     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_11_offset PAGE_ATTR0_SIZE+101     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_12_offset PAGE_ATTR0_SIZE+108    
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_13_offset PAGE_ATTR0_SIZE+115    
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_14_offset PAGE_ATTR0_SIZE+122     
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_15_offset PAGE_ATTR0_SIZE+129    

 
#define OSD_ATTR_NUM_PART_SECURITY_POLICY_ACCESS_TAG_offset PAGE_ATTR0_SIZE+136      
#define OSD_ATTR_NUM_PART_SECURITY_USER_OBJ_POLICY_ACCESS_TAG_offset PAGE_ATTR0_SIZE+140        




#define OSD_ATTR_NUM_PART_SECURITY_DEFAULT_SEC_METHOD_set  1  
#define OSD_ATTR_NUM_PART_SECURITY_OLDEST_VALID_NONCE_set  1        
#define OSD_ATTR_NUM_PART_SECURITY_NEWEST_VALID_NONCE_set  1    
#define OSD_ATTR_NUM_PART_SECURITY_REQ_NONCE_LIST_DEPTH_set 0
#define OSD_ATTR_NUM_PART_SECURITY_FROZEN_KEYS_MASK_set  0
#define OSD_ATTR_NUM_PART_SECURITY_PARTITION_KEY_ID_set 0
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_0_set  0
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_1_set  0    
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_2_set  0  
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_3_set 0
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_4_set 0
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_5_set 0
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_6_set 0
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_7_set 0
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_8_set 0
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_9_set 0
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_10_set 0  
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_11_set 0   
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_12_set 0  
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_13_set 0  
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_14_set 0   
#define OSD_ATTR_NUM_PART_SECURITY_WORKING_KEY_ID_15_set 0   

#define OSD_ATTR_NUM_PART_SECURITY_POLICY_ACCESS_TAG_set 1      
#define OSD_ATTR_NUM_PART_SECURITY_USER_OBJ_POLICY_ACCESS_TAG_set 1

//-------------------------------------------------------------------
//-------------------------------------------------------------------

//OBJECT SEC
#define OSD_PAGE_NUM_UOBJ_SECURITY PAGE_U+0x5     
#define OSD_ATTR_NUM_UOBJ_SECURITY_page_id 0

#define OSD_ATTR_NUM_UOBJ_SECURITY_POLICY_ACCESS_TAG 0x40000001     
#define OSD_ATTR_NUM_UOBJ_SECURITY_POLICY_ACCESS_TAG_size 4
#define OSD_ATTR_NUM_UOBJ_SECURITY_POLICY_ACCESS_TAG_offset PAGE_ATTR0_SIZE+0  
#define OSD_ATTR_NUM_UOBJ_SECURITY_POLICY_ACCESS_TAG_set 1

//-------------------------------------------------------------------
//-------------------------------------------------------------------

//CURRENT COMMAND
#define OSD_PAGE_NUM_CUR_CMD PAGE_A+0xFFFFFFFE     
#define OSD_ATTR_NUM_CUR_CMD_page_id 0

#define OSD_ATTR_NUM_CUR_CMD_RESPONSE_INT_CHECK_VAL 0x1     
#define OSD_ATTR_NUM_CUR_CMD_OBJ_TYPE 0x2     
#define OSD_ATTR_NUM_CUR_CMD_PARTITION_ID 0x3     
#define OSD_ATTR_NUM_CUR_CMD_OBJ_ID 0x4     
#define OSD_ATTR_NUM_CUR_CMD_APPEND_STARTING_BYTE 0x5     

#define OSD_ATTR_NUM_CUR_CMD_RESPONSE_INT_CHECK_VAL_size 20
#define OSD_ATTR_NUM_CUR_CMD_OBJ_TYPE_size 1     
#define OSD_ATTR_NUM_CUR_CMD_PARTITION_ID_size 8     
#define OSD_ATTR_NUM_CUR_CMD_OBJ_ID_size 8
#define OSD_ATTR_NUM_CUR_CMD_APPEND_STARTING_BYTE_size 8    

#define OSD_ATTR_NUM_CUR_CMD_RESPONSE_INT_CHECK_VAL_offset PAGE_ATTR0_SIZE+0     
#define OSD_ATTR_NUM_CUR_CMD_OBJ_TYPE_offset PAGE_ATTR0_SIZE+20     
#define OSD_ATTR_NUM_CUR_CMD_PARTITION_ID_offset PAGE_ATTR0_SIZE+21
#define OSD_ATTR_NUM_CUR_CMD_OBJ_ID_offset PAGE_ATTR0_SIZE+29     
#define OSD_ATTR_NUM_CUR_CMD_APPEND_STARTING_BYTE_offset PAGE_ATTR0_SIZE+37     

#define OSD_ATTR_NUM_CUR_CMD_RESPONSE_INT_CHECK_VAL_set 0
#define OSD_ATTR_NUM_CUR_CMD_OBJ_TYPE_set 0
#define OSD_ATTR_NUM_CUR_CMD_PARTITION_ID_set 0
#define OSD_ATTR_NUM_CUR_CMD_OBJ_ID_set 0
#define OSD_ATTR_NUM_CUR_CMD_APPEND_STARTING_BYTE_set 0

//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------
//Collection directory
#define OSD_PAGE_NUM_COLL_DIRECTORY PAGE_C+0
#define OSD_ATTR_NUM_COLL_DIRECTORY_page_id 0
#define OSD_ATTR_NUM_COLL_DIRECTORY_A1 PAGE_C+1
#define OSD_ATTR_NUM_COLL_DIRECTORY_A3 PAGE_C+3
#define OSD_ATTR_NUM_COLL_DIRECTORY_A5 PAGE_C+5

#define OSD_ATTR_NUM_COLL_DIRECTORY_page_id_size 40
#define OSD_ATTR_NUM_COLL_DIRECTORY_A1_size 40
#define OSD_ATTR_NUM_COLL_DIRECTORY_A3_size 40
#define OSD_ATTR_NUM_COLL_DIRECTORY_A5_size 40

#define OSD_ATTR_NUM_COLL_DIRECTORY_page_id_offset  0
#define OSD_ATTR_NUM_COLL_DIRECTORY_A1_offset  40
#define OSD_ATTR_NUM_COLL_DIRECTORY_A3_offset  80
#define OSD_ATTR_NUM_COLL_DIRECTORY_A5_offset  120

#define OSD_ATTR_NUM_COLL_DIRECTORY_page_id_set  0
#define OSD_ATTR_NUM_COLL_DIRECTORY_A1_set  0
#define OSD_ATTR_NUM_COLL_DIRECTORY_A3_set  0
#define OSD_ATTR_NUM_COLL_DIRECTORY_A5_set  0


//-------------------------------------------------------------------
//-------------------------------------------------------------------

//Collection IFNO
#define OSD_PAGE_NUM_COLL_INFO PAGE_C+0x1
#define OSD_ATTR_NUM_COLL_INFO_page_id 0

#define OSD_ATTR_NUM_COLL_INFO_PARTITION_ID 0x1
#define OSD_ATTR_NUM_COLL_INFO_OBJECT_ID 0x2
#define OSD_ATTR_NUM_COLL_INFO_USERNAME 0x9
#define OSD_ATTR_NUM_COLL_INFO_USED_CAPACITY 0x81

#define OSD_ATTR_NUM_COLL_INFO_PARTITION_ID_size 8
#define OSD_ATTR_NUM_COLL_INFO_OBJECT_ID_size 8
#define OSD_ATTR_NUM_COLL_INFO_USERNAME_size  100
#define OSD_ATTR_NUM_COLL_INFO_USED_CAPACITY_size 8  

#define OSD_ATTR_NUM_COLL_INFO_PARTITION_ID_offset PAGE_ATTR0_SIZE+0
#define OSD_ATTR_NUM_COLL_INFO_OBJECT_ID_offset  PAGE_ATTR0_SIZE+8
#define OSD_ATTR_NUM_COLL_INFO_USERNAME_offset  PAGE_ATTR0_SIZE+16
#define OSD_ATTR_NUM_COLL_INFO_USED_CAPACITY_offset  PAGE_ATTR0_SIZE+116

#define OSD_ATTR_NUM_COLL_INFO_PARTITION_ID_set 0
#define OSD_ATTR_NUM_COLL_INFO_OBJECT_ID_set  0
#define OSD_ATTR_NUM_COLL_INFO_USERNAME_set  1
#define OSD_ATTR_NUM_COLL_INFO_USED_CAPACITY_set  0

//-------------------------------------------------------------------
//-------------------------------------------------------------------
//NO collection quota
//Collection  timestamp

#define OSD_PAGE_NUM_COLL_TIMESTAMPS PAGE_C+0x3
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_page_id 0

#define OSD_ATTR_NUM_COLL_TIMESTAMPS_CREATED_TIME 0x1
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_ATTR_ACCESSED_TIME 0x2
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_ATTR_MODIFIED_TIME 0x3
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_DATA_ACCESSED_TIME 0x4
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_DATA_MODIFIED_TIME 0x5

#define OSD_ATTR_NUM_COLL_TIMESTAMPS_CREATED_TIME_size 6 
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_ATTR_ACCESSED_TIME_size 6
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_ATTR_MODIFIED_TIME_size 6
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_DATA_ACCESSED_TIME_size 6
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_DATA_MODIFIED_TIME_size 6

#define OSD_ATTR_NUM_COLL_TIMESTAMPS_CREATED_TIME_offset PAGE_ATTR0_SIZE+0
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_ATTR_ACCESSED_TIME_offset PAGE_ATTR0_SIZE+6
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_ATTR_MODIFIED_TIME_offset PAGE_ATTR0_SIZE+12
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_DATA_ACCESSED_TIME_offset PAGE_ATTR0_SIZE+18
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_DATA_MODIFIED_TIME_offset PAGE_ATTR0_SIZE+24


#define OSD_ATTR_NUM_COLL_TIMESTAMPS_CREATED_TIME_set 0
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_ATTR_ACCESSED_TIME_set 0
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_ATTR_MODIFIED_TIME_set 0
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_DATA_ACCESSED_TIME_set 0
#define OSD_ATTR_NUM_COLL_TIMESTAMPS_DATA_MODIFIED_TIME_set 0

//-------------------------------------------------------------------
//-------------------------------------------------------------------
//COLLECTION SECURITY

#define OSD_PAGE_NUM_COLL_SECURITY PAGE_C+0x5
#define OSD_ATTR_NUM_COLL_SECURITY_page_id 0

#define OSD_ATTR_NUM_COLL_SECURITY_POLICY_ACCESS_TAG 0x40000001
#define OSD_ATTR_NUM_COLL_SECURITY_POLICY_ACCESS_TAG_size 4 
#define OSD_ATTR_NUM_COLL_SECURITY_POLICY_ACCESS_TAG_offset PAGE_ATTR0_SIZE+0
#define OSD_ATTR_NUM_COLL_SECURITY_POLICY_ACCESS_TAG_set 0

//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------

//IBM VENDOR SPECIFIC ROOT KEYS
#define OSD_PAGE_NUM_IBM_ROOT_KEYS PAGE_R+PAGE_T_VND+1     
#define OSD_ATTR_NUM_IBM_ROOT_KEYS_page_id 0
#define OSD_ATTR_NUM_IBM_ROOT_KEYS_MASTER_AUTH_KEY 1     
#define OSD_ATTR_NUM_IBM_ROOT_KEYS_MASTER_GEN_KEY 2     
#define OSD_ATTR_NUM_IBM_ROOT_KEYS_ROOT_AUTH_KEY 3     
#define OSD_ATTR_NUM_IBM_ROOT_KEYS_ROOT_GEN_KEY 4     

//IBM VENDOR SPEC PART KEYS
#define OSD_PAGE_NUM_IBM_PART_KEYS PAGE_P+PAGE_T_VND+2     
#define OSD_ATTR_NUM_IBM_PART_KEYS_page_id 0
#define OSD_ATTR_NUM_IBM_PART_KEYS_PART_AUTH_KEY 5     
#define OSD_ATTR_NUM_IBM_PART_KEYS_PART_GEN_KEY 6     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_0 0x10     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_1 0x11     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_2 0x12     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_3 0x13     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_4 0x14     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_5 0x15     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_6 0x16     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_7 0x17     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_8 0x18     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_9 0x19     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_10 0x1A     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_11 0x1B     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_12 0x1C     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_13 0x1D     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_14 0x1E     
#define OSD_ATTR_NUM_IBM_PART_KEYS_WORK_KEY_15 0x1F     

//IBM FS DATA
#define OSD_PAGE_NUM_IBM_UOBJ_FS_DATA PAGE_U+PAGE_T_VND+3     
#define OSD_ATTR_NUM_IBM_UOBJ_FS_DATA_page_id 0
#define OSD_ATTR_NUM_IBM_UOBJ_FS_DATA_INODE 1     


#endif /* ifdef OSD_ATTR_NUMBERS_H */
