/**
 *                      ==================
 *                      IITK OSD Simulator
 *                      ==================
 *   An Implementation of Simulator for Object based storage device(OSD)
 *
 *   Copyright (C) 2007-2008 CSE IIT KANPUR
 *
 *   Contact: Department of Computer Science and Engineering
 *            Indian Institute of Technology,Kanpur(IIT Kanpur)
 *            {moona,riyaz}@cse.iitk.ac.in
 *
 *   This file is part of IITK OSD Simulator Project.
 *
 *   IITK OSD Simulator Project is free software; you can redistribute it
 *   and/or modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   IITK OSD Simulator Project is distributed in the hope that it will be
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  GNU General
 *   Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#ifndef OSD_INITIAL_VALUES_H
#define OSD_INITIAL_VALUES_H


/**
********************************
 * File:  osd_initial_values.h
 * Define Macros for Initialization of OSD 
**/

/** Macros for default values in ROOT INFO  page */
# define OSD_ATTR_NUM_ROOT_INFO_OSD_SYSTEM_ID_def_value 
# define OSD_ATTR_NUM_ROOT_INFO_VENDOR_ID_def_value 0
# define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_ID_def_value 0
# define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_MODEL_def_value 0
# define OSD_ATTR_NUM_ROOT_INFO_PRODUCT_REVISION_LEVEL_def_value  0
# define OSD_ATTR_NUM_ROOT_INFO_SERIAL_NUMBER_def_value 0
# define OSD_ATTR_NUM_ROOT_INFO_OSD_NAME_def_value "IIT KANPUR OSD"

/** Macros for default values in ROOT QUOTA  page */
# define OSD_ATTR_NUM_ROOT_QUOTAS_DEFAULT_MAX_OBJ_LEN_def_value 0xFFFFFFFFFFFFFFFFULL
# define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_CAPACITY_QUOTA_def_value 0xFFFFFFFFFFFFFFFFULL
# define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_OBJ_COUNT_def_value 0xFFFFFFFFFFFFFFFFULL
# define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COLLECTIONS_PER_OBJ_def_value 0xFFFFFFFF
# define OSD_ATTR_NUM_ROOT_QUOTAS_PARTITION_COUNT_def_value 0xFFFFFFFFFFFFFFFFULL

/** Macros for default values in ROOT TIMESTAMP  page */
# define OSD_ATTR_NUM_ROOT_TIMESTAMPS_TIMESTAMP_BYPASS_def_value 0

/** Macros for default values in ROOT SECURITY  page */
# define OSD_ATTR_NUM_ROOT_SECURITY_DEFAULT_SEC_METHOD_def_value 0
# define OSD_ATTR_NUM_ROOT_SECURITY_PARTITION_DEFAULT_SEC_METHOD_def_value 0
# define OSD_ATTR_NUM_ROOT_SECURITY_SUPPORTED_SEC_METHODS_def_value 1

# define OSD_ATTR_NUM_PART_SECURITY_POLICY_ACCESS_TAG_def_value 0x7FFFFFFF
# define OSD_ATTR_NUM_PART_SECURITY_USER_OBJ_POLICY_ACCESS_TAG_def_value 0x7FFFFFFF


#endif /* ifdef OSD_INITIAL_VALUES_H */
